function InitializeBuffListener()

  buff_list.EffectAdded = function(sender, args)
    if setContains(bonus_buffs, buff_list:Get(args.Index):GetName()) then
      UpdateBonus()
      UpdateKeeps()
    elseif setContains(outpost_buffs, buff_list:Get(args.Index):GetName()) then
      UpdateOutposts()
    end
  end

  buff_list.EffectRemoved = function(sender, args)
    if setContains(bonus_buffs, args.Effect:GetName()) then
      UpdateBonus()
      UpdateKeeps()
    elseif setContains(outpost_buffs, args.Effect:GetName()) then
      UpdateOutposts()
    end
  end
  
  UpdateOutposts()
  UpdateBonus()
  UpdateKeeps()
end

function UpdateBonus()
  local bonus  = 0
  local bonus1 = 0
  local bonus2 = 0
  
  local treeOwned   = false
  local drakeOwned  = false
  local middleOwned = false

  for i = 1, buff_list:GetCount() do
    local element = buff_list:Get(i):GetName()
    if setContains(bonus_buffs, element)
	  then
	  -- Compute the bonus buff % addition
  	  if ( bonus_buffs[element] == 3 ) then
		    bonus1 = bonus_buffs[ element ]
	    elseif ( bonus_buffs[element] == 5 ) then
		    bonus1 = bonus_buffs[ element ]
	    elseif ( bonus_buffs[element] > 0 ) then
        bonus = bonus + bonus_buffs[element]
      end

	  -- Is this the tree/drake/middle buff?
	  if ( element == dof_buffs[ 1 ] ) then -- Tree
      if ( overviewWindow:IsTreeOwned() == false ) then -- Just got the buff back
        overviewWindow:ResetTreeTimer()
      end
	    overviewWindow:SetTreeOwner( true )
      treeOwned = true
	  elseif ( element == dof_buffs[ 2 ] ) then -- Drake
      if ( overviewWindow:IsDrakeOwned() == false ) then -- Just got the buff back
        overviewWindow:ResetDrakeTimer()
      end
	    overviewWindow:SetDrakeOwner( true )
      drakeOwned = true
	  elseif ( element == dof_buffs[ 3 ] ) then -- Middle
      if ( overviewWindow:IsMiddleOwned() == false ) then -- Just got the buff back
        overviewWindow:ResetMiddleTimer()
      end
	    overviewWindow:SetMiddleOwner( true )
      middleOwned = true
	  end
    end
  end

  -- Reset DOF buff owners
  if ( treeOwned == false ) then
    if ( overviewWindow:IsTreeOwned() == true ) then -- Just lost the buff
      overviewWindow:ResetTreeTimer()
    end
    overviewWindow:SetTreeOwner( false )
  end
  
  if ( drakeOwned == false ) then
    if ( overviewWindow:IsDrakeOwned() == true ) then -- Just lost the buff
      overviewWindow:ResetDrakeTimer()
    end
    overviewWindow:SetDrakeOwner( false )
  end

  if ( middleOwned == false ) then
    if ( overviewWindow:IsMiddleOwned() == true ) then -- Just lost the buff
      overviewWindow:ResetMiddleTimer()
    end
    overviewWindow:SetMiddleOwner( false )
  end
  
  bonus = bonus + bonus1 + bonus2
  
  overviewWindow.label_bonus:SetText(L.BuffWatcher_Bonus..bonus.."%")
  mapWindow:UpdateKeepsOnMap()
end

function UpdateOutposts()
  local bonus = 0
  local bonusChar = {}
 
   for i = 1, buff_list:GetCount() do
    local element = buff_list:Get(i):GetName()
    if setContains(outpost_buffs, element) then
	  bonusChar[ bonus ] = outpost_buffs[ element ]
      bonus = bonus + 1
    end
  end
  
  -- by PulseDiver

  -- Set all OP bar colors to gray
  overviewWindow.outpost1:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost2:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost3:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))
  overviewWindow.outpost4:SetBackColor(Turbine.UI.Color(0.5,0.5,0.5))

  -- Set all OP bar text to blanks
  overviewWindow.outpost1Text:SetText( "" )
  overviewWindow.outpost2Text:SetText( "" )
  overviewWindow.outpost3Text:SetText( "" )
  overviewWindow.outpost4Text:SetText( "" )

  if bonus >= 1
  then
    overviewWindow.outpost1:SetBackColor(AlignmentColor)
    overviewWindow.outpost1Text:SetText(bonusChar[0])
  end
  if bonus >= 2
  then
    overviewWindow.outpost2:SetBackColor(AlignmentColor)
    overviewWindow.outpost2Text:SetText(bonusChar[1])
  end
  if bonus >= 3
  then
    overviewWindow.outpost3:SetBackColor(AlignmentColor)
    overviewWindow.outpost3Text:SetText(bonusChar[2])
  end
  if bonus == 4
  then
    overviewWindow.outpost4:SetBackColor(AlignmentColor)
    overviewWindow.outpost4Text:SetText(bonusChar[3])
  end

  mapWindow:UpdateKeepsOnMap()
end

function UpdateKeeps()
  local found  = 0
  local fCount = 0
  local cCount = 0
  
  --Set all freep displays to blank backgrounds and empty text
  overviewWindow.fKeep1:SetVisible( false )
  overviewWindow.fKeep1Text:SetText( "" )
  overviewWindow.fKeep2:SetVisible( false )
  overviewWindow.fKeep2Text:SetText( "" )
  overviewWindow.fKeep3:SetVisible( false )
  overviewWindow.fKeep3Text:SetText( "" )
  overviewWindow.fKeep4:SetVisible( false )
  overviewWindow.fKeep4Text:SetText( "" )
  overviewWindow.fKeep5:SetVisible( false )
  overviewWindow.fKeep5Text:SetText( "" )

  --Set all creep displays to blank backgrounds and empty text
  overviewWindow.cKeep1:SetVisible( false )
  overviewWindow.cKeep1Text:SetText( "" )
  overviewWindow.cKeep2:SetVisible( false )
  overviewWindow.cKeep2Text:SetText( "" )
  overviewWindow.cKeep3:SetVisible( false )
  overviewWindow.cKeep3Text:SetText( "" )
  overviewWindow.cKeep4:SetVisible( false )
  overviewWindow.cKeep4Text:SetText( "" )
  overviewWindow.cKeep5:SetVisible( false )
  overviewWindow.cKeep5Text:SetText( "" )

  for i = 1, buff_list:GetCount() do
    local buff_elem = buff_list:Get(i):GetName()
    
    if ( buff_elem == L.Monster_Play or Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == Turbine.Gameplay.Alignment.MonsterPlayer )
    then
      found = 1
    end
  end
  
  if ( found == 0 )
  then
    return
  end

  for i = 1, 5 do
    local element = rkeeps[ i ]

    found = 0
    
    -- Freep side
    if ( Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() ~= Turbine.Gameplay.Alignment.MonsterPlayer ) then
      for j = 1, buff_list:GetCount() do
        local buff_elem = buff_list:Get(j):GetName()
        
        if ( element == buff_elem ) then
          if ( fCount == 0 ) then
            overviewWindow.fKeep1:SetVisible( true )
            overviewWindow.fKeep1Text:SetText( keeps_acr[ element ] )
          elseif ( fCount == 1 ) then
            overviewWindow.fKeep2:SetVisible( true )
            overviewWindow.fKeep2Text:SetText( keeps_acr[ element ] )
          elseif ( fCount == 2 ) then
            overviewWindow.fKeep3:SetVisible( true )
            overviewWindow.fKeep3Text:SetText( keeps_acr[ element ] )
          elseif ( fCount == 3 ) then
            overviewWindow.fKeep4:SetVisible( true )
            overviewWindow.fKeep4Text:SetText( keeps_acr[ element ] )
          elseif ( fCount == 4 ) then
            overviewWindow.fKeep5:SetVisible( true )
            overviewWindow.fKeep5Text:SetText( keeps_acr[ element ] )
          end

          fCount = fCount + 1

          found = 1
          j = buff_list:GetCount()
        end
      end
    
      if ( found == 0 )
      then
        if ( cCount == 0 ) then
          overviewWindow.cKeep1:SetVisible( true )
          overviewWindow.cKeep1Text:SetText( keeps_acr[ element ] )
        elseif ( cCount == 1 ) then
          overviewWindow.cKeep2:SetVisible( true )
          overviewWindow.cKeep2Text:SetText( keeps_acr[ element ] )
        elseif ( cCount == 2 ) then
          overviewWindow.cKeep3:SetVisible( true )
          overviewWindow.cKeep3Text:SetText( keeps_acr[ element ] )
        elseif ( cCount == 3 ) then
          overviewWindow.cKeep4:SetVisible( true )
          overviewWindow.cKeep4Text:SetText( keeps_acr[ element ] )
        elseif ( cCount == 4 ) then
          overviewWindow.cKeep5:SetVisible( true )
          overviewWindow.cKeep5Text:SetText( keeps_acr[ element ] )
        end

        cCount = cCount + 1
      end
      
    else -- Monster player section
      
      for j = 1, buff_list:GetCount() do
        local buff_elem = buff_list:Get(j):GetName()
        
        if ( element == buff_elem ) then
          if ( cCount == 0 ) then
            overviewWindow.cKeep1:SetVisible( true )
            overviewWindow.cKeep1Text:SetText( keeps_acr[ element ] )
          elseif ( cCount == 1 ) then
            overviewWindow.cKeep2:SetVisible( true )
            overviewWindow.cKeep2Text:SetText( keeps_acr[ element ] )
          elseif ( cCount == 2 ) then
            overviewWindow.cKeep3:SetVisible( true )
            overviewWindow.cKeep3Text:SetText( keeps_acr[ element ] )
          elseif ( cCount == 3 ) then
            overviewWindow.cKeep4:SetVisible( true )
            overviewWindow.cKeep4Text:SetText( keeps_acr[ element ] )
          elseif ( cCount == 4 ) then
            overviewWindow.cKeep5:SetVisible( true )
            overviewWindow.cKeep5Text:SetText( keeps_acr[ element ] )
          end

          cCount = cCount + 1

          found = 1
          j = buff_list:GetCount()
        end
      end
    
      if ( found == 0 )
      then
        if ( fCount == 0 ) then
          overviewWindow.fKeep1:SetVisible( true )
          overviewWindow.fKeep1Text:SetText( keeps_acr[ element ] )
        elseif ( fCount == 1 ) then
          overviewWindow.fKeep2:SetVisible( true )
          overviewWindow.fKeep2Text:SetText( keeps_acr[ element ] )
        elseif ( fCount == 2 ) then
          overviewWindow.fKeep3:SetVisible( true )
          overviewWindow.fKeep3Text:SetText( keeps_acr[ element ] )
        elseif ( fCount == 3 ) then
          overviewWindow.fKeep4:SetVisible( true )
          overviewWindow.fKeep4Text:SetText( keeps_acr[ element ] )
        elseif ( fCount == 4 ) then
          overviewWindow.fKeep5:SetVisible( true )
          overviewWindow.fKeep5Text:SetText( keeps_acr[ element ] )
        end

        fCount = fCount + 1
      end
    end
  end    
    
end

function setContains(set, key)
    return set[key]
end
