OverviewWindow = class(Turbine.UI.Window)
 
local ownTree   = false
local ownDrake  = false
local ownMiddle = false
 
local treeTimer   = 0
local drakeTimer  = 0
local middleTimer = 0
 
function OverviewWindow:Constructor()

  Turbine.UI.Window.Constructor(self)
  local width = math.ceil(minimal_width + (Turbine.UI.Display.GetWidth() - minimal_width) * data.numbers.overview_width_ratio)
  local height = 90
	self:SetSize(width,height)

	self:SetPosition(data.numbers.overview_x,data.numbers.overview_y)
  self:SetWantsKeyEvents(true)
  self:SetMouseVisible(false)
  
  self.DragBar = DragBar(self, "PvMP+")

  self.panel = Turbine.UI.Label()
	self.panel:SetParent(self)
	self.panel:SetSize(width,height)
  self.panel:SetMouseVisible(false)
  
	self.bar_start = 50
	self.bar_end = self:GetWidth() - self.bar_start
	self.bar_length = self.bar_end - self.bar_start
	--
	self.empty_bar = Turbine.UI.Label()
	self.empty_bar:SetParent(self.panel)
	self.empty_bar:SetSize(self.bar_length,14)
	self.empty_bar:SetPosition(self.bar_start,27)
	self.empty_bar:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_empty.tga")
	self.empty_bar:SetMouseVisible(false)

	self.filled_bar = Turbine.UI.Label()
	self.filled_bar:SetParent(self.panel)
	self.filled_bar:SetSize(0,14)
	self.filled_bar:SetPosition(self.bar_start,27)
	self.filled_bar:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_filled.tga")
	self.filled_bar:SetMouseVisible(false)

	self.left_end = Turbine.UI.Label()
	self.left_end:SetParent(self.panel)
	self.left_end:SetSize(6,18)
	self.left_end:SetPosition(self.bar_start-3,25)
	self.left_end:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_left.tga")
	self.left_end:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.left_end:SetMouseVisible(false)

	self.right_end = Turbine.UI.Label()
	self.right_end:SetParent(self.panel)
	self.right_end:SetSize(6,18)
	self.right_end:SetPosition(self.bar_end-3,25)
	self.right_end:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_right.tga")	
	self.right_end:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.right_end:SetMouseVisible(false)
	
	self.middle = Turbine.UI.Label()
	self.middle:SetParent(self.panel)
	self.middle:SetSize(self.bar_length-6,18)
	self.middle:SetPosition(self.bar_start+3,25)
	self.middle:SetBackground("PvMP_Plus/Resources/ProgressBar/bar_middle.tga")	
	self.middle:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.middle:SetMouseVisible(false)
	
	self.percentage = Turbine.UI.Label()
	self.percentage:SetParent(self.panel)
  self.percentage:SetSize(width,18)
  self.percentage:SetPosition(0,25)
  self.percentage:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self.percentage:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
	self.percentage:SetMouseVisible(false)
	
  ------------------------------------------------------------
  self.bonus_panel = Turbine.UI.Label()
  self.bonus_panel:SetParent(self.panel)
  self.bonus_panel:SetSize(95,30) -- label direkt zwischen rank- und commendations-label
	self.bonus_panel:SetPosition(width/2-self.bonus_panel:GetSize()/2,0)
  self.bonus_panel:SetMouseVisible(false)
  self.bonus_panel:SetVisible(not storage.show_bonus_disabled)

  self.label_bonus = Turbine.UI.Label()
  self.label_bonus:SetParent(self.bonus_panel)
  self.label_bonus:SetSize(self.bonus_panel:GetSize())
	self.label_bonus:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
  self.label_bonus:SetFont(Turbine.UI.Lotro.Font.Verdana12)
	self.label_bonus:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.label_bonus:SetMouseVisible(false)

  self.outpost1 = Turbine.UI.Label()
  self.outpost1:SetParent(self.bonus_panel)
  self.outpost1:SetSize(20,3)
	self.outpost1:SetPosition(0,18)
  self.outpost1:SetMouseVisible(false)

  -- Make a label that sits over the OP color label, this will have the letter of the OP that it represents
  self.outpost1Text = Turbine.UI.Label()
  self.outpost1Text:SetParent(self.bonus_panel)
  self.outpost1Text:SetSize(20,16)
  self.outpost1Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.outpost1Text:SetPosition(0,11)
  self.outpost1Text:SetMouseVisible(false)
  self.outpost1Text:SetText("")
  self.outpost1Text:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self.outpost1Text:SetFontStyle(Turbine.UI.FontStyle.Outline)

  self.outpost2 = Turbine.UI.Label()
  self.outpost2:SetParent(self.bonus_panel)
  self.outpost2:SetSize(20,3)
	self.outpost2:SetPosition(25,18)
  self.outpost2:SetMouseVisible(false)
  
  -- Make a label that sits over the OP color label, this will have the letter of the OP that it represents
  self.outpost2Text = Turbine.UI.Label()
  self.outpost2Text:SetParent(self.bonus_panel)
  self.outpost2Text:SetSize(20,16)
  self.outpost2Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.outpost2Text:SetPosition(25,11)
  self.outpost2Text:SetMouseVisible(false)
  self.outpost2Text:SetText("")
  self.outpost2Text:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self.outpost2Text:SetFontStyle(Turbine.UI.FontStyle.Outline)

  self.outpost3 = Turbine.UI.Label()
  self.outpost3:SetParent(self.bonus_panel)
  self.outpost3:SetSize(20,3)
	self.outpost3:SetPosition(50,18)
  self.outpost3:SetMouseVisible(false)

  -- Make a label that sits over the OP color label, this will have the letter of the OP that it represents
  self.outpost3Text = Turbine.UI.Label()
  self.outpost3Text:SetParent(self.bonus_panel)
  self.outpost3Text:SetSize(20,16)
  self.outpost3Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.outpost3Text:SetPosition(50,11)
  self.outpost3Text:SetMouseVisible(false)
  self.outpost3Text:SetText("")
  self.outpost3Text:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self.outpost3Text:SetFontStyle(Turbine.UI.FontStyle.Outline)

  self.outpost4 = Turbine.UI.Label()
  self.outpost4:SetParent(self.bonus_panel)
  self.outpost4:SetSize(20,3)
	self.outpost4:SetPosition(75,18)
  self.outpost4:SetMouseVisible(false)
  
  -- Make a label that sits over the OP color label, this will have the letter of the OP that it represents
  self.outpost4Text = Turbine.UI.Label()
  self.outpost4Text:SetParent(self.bonus_panel)
  self.outpost4Text:SetSize(20,16)
  self.outpost4Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.outpost4Text:SetPosition(75,11)
  self.outpost4Text:SetMouseVisible(false)
  self.outpost4Text:SetText("")
  self.outpost4Text:SetFont(Turbine.UI.Lotro.Font.Verdana12)
  self.outpost4Text:SetFontStyle(Turbine.UI.FontStyle.Outline)

  ------------------------------------------------------------
  --DMG MODS
  self.fKeep1 = Turbine.UI.Label()
  self.fKeep1:SetParent(self.panel)
  self.fKeep1:SetSize(24,24)
  self.fKeep1:SetPosition(width/2-self.bonus_panel:GetSize()/2-30,0)
  self.fKeep1:SetBackground("PvMP_Plus/Resources/KeepIcons/BlueFire.jpg")	
  self.fKeep1:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.fKeep1:SetMouseVisible(false)
  self.fKeep1:SetVisible(false)

  self.fKeep1Text = Turbine.UI.Label()
  self.fKeep1Text:SetParent(self.panel)
  self.fKeep1Text:SetSize(24,24)
  self.fKeep1Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.fKeep1Text:SetPosition(width/2-self.bonus_panel:GetSize()/2-30,2)
  self.fKeep1Text:SetMouseVisible(false)
  self.fKeep1Text:SetText("")
  self.fKeep1Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.fKeep1Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.fKeep2 = Turbine.UI.Label()
  self.fKeep2:SetParent(self.panel)
  self.fKeep2:SetSize(24,24)
  self.fKeep2:SetPosition(width/2-self.bonus_panel:GetSize()/2-55,0)
  self.fKeep2:SetBackground("PvMP_Plus/Resources/KeepIcons/BlueFire.jpg")	
  self.fKeep2:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.fKeep2:SetMouseVisible(false)
  self.fKeep2:SetVisible(false)

  self.fKeep2Text = Turbine.UI.Label()
  self.fKeep2Text:SetParent(self.panel)
  self.fKeep2Text:SetSize(24,24)
  self.fKeep2Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.fKeep2Text:SetPosition(width/2-self.bonus_panel:GetSize()/2-55,2)
  self.fKeep2Text:SetMouseVisible(false)
  self.fKeep2Text:SetText("")
  self.fKeep2Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.fKeep2Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.fKeep3 = Turbine.UI.Label()
  self.fKeep3:SetParent(self.panel)
  self.fKeep3:SetSize(24,24)
  self.fKeep3:SetPosition(width/2-self.bonus_panel:GetSize()/2-80,0)
  self.fKeep3:SetBackground("PvMP_Plus/Resources/KeepIcons/BlueFire.jpg")	
  self.fKeep3:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.fKeep3:SetMouseVisible(false)
  self.fKeep3:SetVisible(false)

  self.fKeep3Text = Turbine.UI.Label()
  self.fKeep3Text:SetParent(self.panel)
  self.fKeep3Text:SetSize(24,24)
  self.fKeep3Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.fKeep3Text:SetPosition(width/2-self.bonus_panel:GetSize()/2-80,2)
  self.fKeep3Text:SetMouseVisible(false)
  self.fKeep3Text:SetText("")
  self.fKeep3Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.fKeep3Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.fKeep4 = Turbine.UI.Label()
  self.fKeep4:SetParent(self.panel)
  self.fKeep4:SetSize(24,24)
  self.fKeep4:SetPosition(width/2-self.bonus_panel:GetSize()/2-105,0)
  self.fKeep4:SetBackground("PvMP_Plus/Resources/KeepIcons/BlueFire.jpg")	
  self.fKeep4:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.fKeep4:SetMouseVisible(false)
  self.fKeep4:SetVisible(false)

  self.fKeep4Text = Turbine.UI.Label()
  self.fKeep4Text:SetParent(self.panel)
  self.fKeep4Text:SetSize(24,24)
  self.fKeep4Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.fKeep4Text:SetPosition(width/2-self.bonus_panel:GetSize()/2-105,2)
  self.fKeep4Text:SetMouseVisible(false)
  self.fKeep4Text:SetText("")
  self.fKeep4Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.fKeep4Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.fKeep5 = Turbine.UI.Label()
  self.fKeep5:SetParent(self.panel)
  self.fKeep5:SetSize(24,24)
  self.fKeep5:SetPosition(width/2-self.bonus_panel:GetSize()/2-130,0)
  self.fKeep5:SetBackground("PvMP_Plus/Resources/KeepIcons/BlueFire.jpg")	
  self.fKeep5:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.fKeep5:SetMouseVisible(false)
  self.fKeep5:SetVisible(false)

  self.fKeep5Text = Turbine.UI.Label()
  self.fKeep5Text:SetParent(self.panel)
  self.fKeep5Text:SetSize(24,24)
  self.fKeep5Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.fKeep5Text:SetPosition(width/2-self.bonus_panel:GetSize()/2-130,2)
  self.fKeep5Text:SetMouseVisible(false)
  self.fKeep5Text:SetText("")
  self.fKeep5Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.fKeep5Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.cKeep1 = Turbine.UI.Label()
  self.cKeep1:SetParent(self.panel)
  self.cKeep1:SetSize(24,24)
  self.cKeep1:SetPosition(width/2+self.bonus_panel:GetSize()/2+6,0)
  self.cKeep1:SetBackground("PvMP_Plus/Resources/KeepIcons/RedFire.jpg")	
  self.cKeep1:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.cKeep1:SetMouseVisible(false)

  self.cKeep1Text = Turbine.UI.Label()
  self.cKeep1Text:SetParent(self.panel)
  self.cKeep1Text:SetSize(24,24)
  self.cKeep1Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.cKeep1Text:SetPosition(width/2+self.bonus_panel:GetSize()/2+6,2)
  self.cKeep1Text:SetMouseVisible(false)
  self.cKeep1Text:SetText("")
  self.cKeep1Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.cKeep1Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.cKeep2 = Turbine.UI.Label()
  self.cKeep2:SetParent(self.panel)
  self.cKeep2:SetSize(24,24)
  self.cKeep2:SetPosition(width/2+self.bonus_panel:GetSize()/2+31,0)
  self.cKeep2:SetBackground("PvMP_Plus/Resources/KeepIcons/RedFire.jpg")	
  self.cKeep2:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.cKeep2:SetMouseVisible(false)

  self.cKeep2Text = Turbine.UI.Label()
  self.cKeep2Text:SetParent(self.panel)
  self.cKeep2Text:SetSize(24,24)
  self.cKeep2Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.cKeep2Text:SetPosition(width/2+self.bonus_panel:GetSize()/2+31,2)
  self.cKeep2Text:SetMouseVisible(false)
  self.cKeep2Text:SetText("")
  self.cKeep2Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.cKeep2Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.cKeep3 = Turbine.UI.Label()
  self.cKeep3:SetParent(self.panel)
  self.cKeep3:SetSize(24,24)
  self.cKeep3:SetPosition(width/2+self.bonus_panel:GetSize()/2+56,0)
  self.cKeep3:SetBackground("PvMP_Plus/Resources/KeepIcons/RedFire.jpg")	
  self.cKeep3:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.cKeep3:SetMouseVisible(false)

  self.cKeep3Text = Turbine.UI.Label()
  self.cKeep3Text:SetParent(self.panel)
  self.cKeep3Text:SetSize(24,24)
  self.cKeep3Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.cKeep3Text:SetPosition(width/2+self.bonus_panel:GetSize()/2+56,2)
  self.cKeep3Text:SetMouseVisible(false)
  self.cKeep3Text:SetText("")
  self.cKeep3Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.cKeep3Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.cKeep4 = Turbine.UI.Label()
  self.cKeep4:SetParent(self.panel)
  self.cKeep4:SetSize(24,24)
  self.cKeep4:SetPosition(width/2+self.bonus_panel:GetSize()/2+81,0)
  self.cKeep4:SetBackground("PvMP_Plus/Resources/KeepIcons/RedFire.jpg")	
  self.cKeep4:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.cKeep4:SetMouseVisible(false)

  self.cKeep4Text = Turbine.UI.Label()
  self.cKeep4Text:SetParent(self.panel)
  self.cKeep4Text:SetSize(24,24)
  self.cKeep4Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.cKeep4Text:SetPosition(width/2+self.bonus_panel:GetSize()/2+81,2)
  self.cKeep4Text:SetMouseVisible(false)
  self.cKeep4Text:SetText("")
  self.cKeep4Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.cKeep4Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.cKeep5 = Turbine.UI.Label()
  self.cKeep5:SetParent(self.panel)
  self.cKeep5:SetSize(24,24)
  self.cKeep5:SetPosition(width/2+self.bonus_panel:GetSize()/2+106,0)
  self.cKeep5:SetBackground("PvMP_Plus/Resources/KeepIcons/RedFire.jpg")	
  self.cKeep5:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.cKeep5:SetMouseVisible(false)

  self.cKeep5Text = Turbine.UI.Label()
  self.cKeep5Text:SetParent(self.panel)
  self.cKeep5Text:SetSize(24,24)
  self.cKeep5Text:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.cKeep5Text:SetPosition(width/2+self.bonus_panel:GetSize()/2+106,2)
  self.cKeep5Text:SetMouseVisible(false)
  self.cKeep5Text:SetText("")
  self.cKeep5Text:SetFont(Turbine.UI.Lotro.Font.Verdana16 )
  self.cKeep5Text:SetFontStyle(Turbine.UI.FontStyle.Outline)
    
  ------------------------------------------------------------
  -- DELVING BUFF TIMERS
  self.fDelv1Icon = Turbine.UI.Label()
  self.fDelv1Icon:SetParent(self.panel)
  self.fDelv1Icon:SetSize(32,32) -- Set the size of the icon first
  self.fDelv1Icon:SetPosition(width/2-self.bonus_panel:GetSize()/2-151,0)
  self.fDelv1Icon:SetBackground(0x4112D3CD)	-- Set the image next
  self.fDelv1Icon:SetStretchMode( 1 ) -- Set the stretch mode
  self.fDelv1Icon:SetSize(15,15) -- Set the actual usable size we want (viola! stretching!)
  self.fDelv1Icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.fDelv1Icon:SetMouseVisible(false)
  self.fDelv1Icon:SetVisible(true)

  self.fDelv1Time = Turbine.UI.Label()
  self.fDelv1Time:SetParent(self.panel)
  self.fDelv1Time:SetSize(30,15)
  self.fDelv1Time:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
  self.fDelv1Time:SetPosition(width/2-self.bonus_panel:GetSize()/2-159,13)
  self.fDelv1Time:SetMouseVisible(false)
  self.fDelv1Time:SetText("0:00")
  self.fDelv1Time:SetFont(Turbine.UI.Lotro.Font.Verdana12 )
  self.fDelv1Time:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.fDelv2Icon = Turbine.UI.Label()
  self.fDelv2Icon:SetParent(self.panel)
  self.fDelv2Icon:SetSize(32,32) -- Set the size of the icon first
  self.fDelv2Icon:SetPosition(width/2-self.bonus_panel:GetSize()/2-183,0)
  self.fDelv2Icon:SetBackground(0x4112D3CE)	-- Set the image next
  self.fDelv2Icon:SetStretchMode( 1 ) -- Set the stretch mode
  self.fDelv2Icon:SetSize(15,15) -- Set the actual usable size we want (viola! stretching!)
  self.fDelv2Icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.fDelv2Icon:SetMouseVisible(false)
  self.fDelv2Icon:SetVisible(true)

  self.fDelv2Time = Turbine.UI.Label()
  self.fDelv2Time:SetParent(self.panel)
  self.fDelv2Time:SetSize(30,15)
  self.fDelv2Time:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
  self.fDelv2Time:SetPosition(width/2-self.bonus_panel:GetSize()/2-191,13)
  self.fDelv2Time:SetMouseVisible(false)
  self.fDelv2Time:SetText("0:00")
  self.fDelv2Time:SetFont(Turbine.UI.Lotro.Font.Verdana12 )
  self.fDelv2Time:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.fDelv3Icon = Turbine.UI.Label()
  self.fDelv3Icon:SetParent(self.panel)
  self.fDelv3Icon:SetSize(32,32) -- Set the size of the icon first
  self.fDelv3Icon:SetPosition(width/2-self.bonus_panel:GetSize()/2-215,0)
  self.fDelv3Icon:SetBackground(0x4112D3D0)	-- Set the image next
  self.fDelv3Icon:SetStretchMode( 1 ) -- Set the stretch mode
  self.fDelv3Icon:SetSize(15,15) -- Set the actual usable size we want (viola! stretching!)
  self.fDelv3Icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.fDelv3Icon:SetMouseVisible(false)
  self.fDelv3Icon:SetVisible(true)

  self.fDelv3Time = Turbine.UI.Label()
  self.fDelv3Time:SetParent(self.panel)
  self.fDelv3Time:SetSize(30,15)
  self.fDelv3Time:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
  self.fDelv3Time:SetPosition(width/2-self.bonus_panel:GetSize()/2-223,13)
  self.fDelv3Time:SetMouseVisible(false)
  self.fDelv3Time:SetText("0:00")
  self.fDelv3Time:SetFont(Turbine.UI.Lotro.Font.Verdana12 )
  self.fDelv3Time:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.cDelv1Icon = Turbine.UI.Label()
  self.cDelv1Icon:SetParent(self.panel)
  self.cDelv1Icon:SetSize(32,32) -- Set the size of the icon first
  self.cDelv1Icon:SetPosition(width/2-self.bonus_panel:GetSize()/2+231,0)
  self.cDelv1Icon:SetBackground(0x4112D3CD)	-- Set the image next
  self.cDelv1Icon:SetStretchMode( 1 ) -- Set the stretch mode
  self.cDelv1Icon:SetSize(15,15) -- Set the actual usable size we want (viola! stretching!)
  self.cDelv1Icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.cDelv1Icon:SetMouseVisible(false)
  self.cDelv1Icon:SetVisible(true)

  self.cDelv1Time = Turbine.UI.Label()
  self.cDelv1Time:SetParent(self.panel)
  self.cDelv1Time:SetSize(30,15)
  self.cDelv1Time:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
  self.cDelv1Time:SetPosition(width/2-self.bonus_panel:GetSize()/2+223,13)
  self.cDelv1Time:SetMouseVisible(false)
  self.cDelv1Time:SetText("0:00")
  self.cDelv1Time:SetFont(Turbine.UI.Lotro.Font.Verdana12 )
  self.cDelv1Time:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.cDelv2Icon = Turbine.UI.Label()
  self.cDelv2Icon:SetParent(self.panel)
  self.cDelv2Icon:SetSize(32,32) -- Set the size of the icon first
  self.cDelv2Icon:SetPosition(width/2-self.bonus_panel:GetSize()/2+265,0)
  self.cDelv2Icon:SetBackground(0x4112D3CE)	-- Set the image next
  self.cDelv2Icon:SetStretchMode( 1 ) -- Set the stretch mode
  self.cDelv2Icon:SetSize(15,15) -- Set the actual usable size we want (viola! stretching!)
  self.cDelv2Icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.cDelv2Icon:SetMouseVisible(false)
  self.cDelv2Icon:SetVisible(true)

  self.cDelv2Time = Turbine.UI.Label()
  self.cDelv2Time:SetParent(self.panel)
  self.cDelv2Time:SetSize(30,15)
  self.cDelv2Time:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
  self.cDelv2Time:SetPosition(width/2-self.bonus_panel:GetSize()/2+257,13)
  self.cDelv2Time:SetMouseVisible(false)
  self.cDelv2Time:SetText("0:00")
  self.cDelv2Time:SetFont(Turbine.UI.Lotro.Font.Verdana12 )
  self.cDelv2Time:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  self.cDelv3Icon = Turbine.UI.Label()
  self.cDelv3Icon:SetParent(self.panel)
  self.cDelv3Icon:SetSize(32,32) -- Set the size of the icon first
  self.cDelv3Icon:SetPosition(width/2-self.bonus_panel:GetSize()/2+299,0)
  self.cDelv3Icon:SetBackground(0x4112D3D0)	-- Set the image next
  self.cDelv3Icon:SetStretchMode( 1 ) -- Set the stretch mode
  self.cDelv3Icon:SetSize(15,15) -- Set the actual usable size we want (viola! stretching!)
  self.cDelv3Icon:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
  self.cDelv3Icon:SetMouseVisible(false)
  self.cDelv3Icon:SetVisible(true)

  self.cDelv3Time = Turbine.UI.Label()
  self.cDelv3Time:SetParent(self.panel)
  self.cDelv3Time:SetSize(30,15)
  self.cDelv3Time:SetTextAlignment(Turbine.UI.ContentAlignment.TopCenter)
  self.cDelv3Time:SetPosition(width/2-self.bonus_panel:GetSize()/2+291,13)
  self.cDelv3Time:SetMouseVisible(false)
  self.cDelv3Time:SetText("0:00")
  self.cDelv3Time:SetFont(Turbine.UI.Lotro.Font.Verdana12 )
  self.cDelv3Time:SetFontStyle(Turbine.UI.FontStyle.Outline)
  
  ------------------------------------------------------------
  self.label_points = Turbine.UI.Label()
  self.label_points:SetParent(self.panel)
  self.label_points:SetSize(width - 108,20) -- label direkt zwischen rank- und commendations-label
  self.label_points:SetForeColor(default_font_color)
	self.label_points:SetPosition(width/2-self.label_points:GetSize()/2,45)
	self.label_points:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.label_points:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
	self.label_points:SetFontStyle(Turbine.UI.FontStyle.Outline)
	------------------------------------------------------------
  self.points_panel = Turbine.UI.Label()
  self.points_panel:SetParent(self.panel)
  self.points_panel:SetSize(width,20)
	self.points_panel:SetPosition(0,70)
	self.points_panel:SetMouseVisible(false)
  self.label_day = OverviewLabel(self.points_panel,width,0,default_font_color)
  self.label_last_hour = OverviewLabel(self.points_panel,width,1,default_font_color)
  self.label_10min = OverviewLabel(self.points_panel,width,2,default_font_color)
  self.label_last_fight = OverviewLabel(self.points_panel,width,3,default_font_color)
	------------------------------------------------------------
  self.comms_panel = Turbine.UI.Label()
  self.comms_panel:SetParent(self.panel)
  self.comms_panel:SetSize(width,20)
	self.comms_panel:SetPosition(0,70)
	self.comms_panel:SetMouseVisible(false)
  self.comms_panel:SetVisible(false)
  self.label_day_comms = OverviewLabel(self.comms_panel,width,0, Turbine.UI.Color(0/255,253/255,255/255))
  self.label_last_hour_comms = OverviewLabel(self.comms_panel,width,1, Turbine.UI.Color(0/255,253/255,255/255))
  self.label_10min_comms = OverviewLabel(self.comms_panel,width,2, Turbine.UI.Color(0/255,253/255,255/255))
  self.label_last_fight_comms = OverviewLabel(self.comms_panel,width,3, Turbine.UI.Color(0/255,253/255,255/255))
	------------------------------------------------------------
  self.commendations_panel = Turbine.UI.Label()
  self.commendations_panel:SetParent(self.panel)
  self.commendations_panel:SetSize(54,50)
	self.commendations_panel:SetPosition(width-54,18)
  self.commendations_panel.MouseEnter = function()
    if not storage.stats_hidden then
      self.points_panel:SetVisible(false)
      self.comms_panel:SetVisible(true)
    end
  end
  self.commendations_panel.MouseLeave = function()
    if not storage.stats_hidden then
      self.points_panel:SetVisible(true)
      self.comms_panel:SetVisible(false)
    end
  end
  ------------------------------------------------------------
  self.label_commendations = Turbine.UI.Label()
  self.label_commendations:SetParent(self.commendations_panel)
  self.label_commendations:SetSize(54,20)
  self.label_commendations:SetForeColor(default_font_color)
	self.label_commendations:SetPosition(0,30)
	self.label_commendations:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.label_commendations:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
	self.label_commendations:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.label_commendations:SetMouseVisible(false)
  ------------------------------------------------------------
  self.pic_commendations = Turbine.UI.Control()
  self.pic_commendations:SetParent(self.commendations_panel)
  self.pic_commendations:SetSize(32,32)
	self.pic_commendations:SetPosition(11,0)
	self.pic_commendations:SetBackground(0x41123495)
	self.pic_commendations:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.pic_commendations:SetMouseVisible(false)
  ------------------------------------------------------------
	self.label_rank = Turbine.UI.Label()
  self.label_rank:SetParent(self.panel)
  self.label_rank:SetSize(54,20)
  self.label_rank:SetForeColor(default_font_color)
	self.label_rank:SetPosition(0,48)
	self.label_rank:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.label_rank:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
	self.label_rank:SetFontStyle(Turbine.UI.FontStyle.Outline)
	self.label_rank:SetMouseVisible(false)
  ------------------------------------------------------------
  self.pic_rank = Turbine.UI.Control()
  self.pic_rank:SetParent(self.panel)
  self.pic_rank:SetSize(32,32)
	self.pic_rank:SetPosition(11,18)
	self.pic_rank:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
	self.pic_rank:SetMouseVisible(false)
  ------------------------------------------------------------
	self.separator = Turbine.UI.Control()
  self.separator:SetParent(self.panel)
  self.separator:SetSize(width,1)
	self.separator:SetPosition(0,70)
	self.separator:SetBackColor(default_font_color)
	self.separator:SetMouseVisible(false)
	------------------------------------------------------------
	self:SetStatsVisibility(not storage.stats_hidden)
	------------------------------------------------------------

  self.PositionChanged = function(sender, args)
		data.numbers.overview_x = self:GetLeft()
		data.numbers.overview_y = self:GetTop()
    overview_settings_panel:SetPosition(self:GetLeft() + self:GetWidth() - overview_settings_panel:GetWidth(), self:GetTop())	
  end
  
	self.label_points.MouseDown = function()
		storage.show_remaining_points = not storage.show_remaining_points
		self:Update()
	end
	
  self.KeyDown = function(sender,args) 
    if args.Action == Turbine.UI.Lotro.Action.ToggleHUD then
			self:SetVisible(not self:IsVisible()) -- toggle visibility of Overview-Window
			overview_settings_panel:SetVisible(not overview_settings_panel:IsVisible()) -- toggle visibility of Overview-Control
      secondaryWindow:SetVisible(not (secondaryWindow:IsVisible() or storage.secondaryMinimized or storage.minimized))      
      alertWindow:SetVisible(not alertWindow:IsVisible())
    end
  end
	
end

function OverviewWindow:Update()

  local text    = ""
  local hours   = 0
  local minutes = 0
  local minuteMod = 0
  
  commsLast24h, commsLastHour, commsLast10Min = GetRecentData(data.numbers.recent_comms)
  pointsLast24h, pointsLastHour, pointsLast10Min = GetRecentData(data.numbers.recent_points)

  self.label_commendations:SetText(FormatPoints(current_commendations))

	if self:GetWidth() < 600 then
		if storage.show_remaining_points then
			self.label_points:SetText(L.Stats_Remaining_Points_Short .. FormatPoints(GetRemainingPoints()))
		else
			self.label_points:SetText(L.Stats_Total_Points_Short .. FormatPoints(data.numbers.points_total))
		end
		self.label_day:SetText(L.Stats_Current_Day_Short .. FormatPoints(data.numbers.points_current_day))
		self.label_last_hour:SetText(L.Stats_Last_Hour_Short.. pointsLastHour)
		self.label_10min:SetText(L.Stats_Last_10min_Short .. pointsLast10Min)
		self.label_last_fight:SetText(L.Stats_Last_Fight_Short .. FormatPoints(points_last_fight))
		self.label_day_comms:SetText(L.Stats_Current_Day_Short .. FormatPoints(data.numbers.comms_current_day))
		self.label_last_hour_comms:SetText(L.Stats_Last_Hour_Short.. commsLastHour)
		self.label_10min_comms:SetText(L.Stats_Last_10min_Short .. commsLast10Min)
		self.label_last_fight_comms:SetText(L.Stats_Last_Fight_Short .. comms_last_fight)
	else
		if storage.show_remaining_points then
			self.label_points:SetText(L.Stats_Remaining_Points .. FormatPoints(GetRemainingPoints()))
		else
			self.label_points:SetText(L.Stats_Total_Points .. FormatPoints(data.numbers.points_total))
		end
		self.label_day:SetText(L.Stats_Current_Day .. FormatPoints(data.numbers.points_current_day))
		self.label_last_hour:SetText(L.Stats_Last_Hour.. pointsLastHour)
		self.label_10min:SetText(L.Stats_Last_10min .. pointsLast10Min)
		self.label_last_fight:SetText(L.Stats_Last_Fight .. FormatPoints(points_last_fight))
		self.label_day_comms:SetText(L.Stats_Current_Day .. FormatPoints(data.numbers.comms_current_day))
		self.label_last_hour_comms:SetText(L.Stats_Last_Hour.. commsLastHour)
		self.label_10min_comms:SetText(L.Stats_Last_10min .. commsLast10Min)
		self.label_last_fight_comms:SetText(L.Stats_Last_Fight .. FormatPoints(comms_last_fight))

	end

	overview_settings_panel:UpdateChatData()
  
  -- Resize the icons each iteration because sometimes they go all wonky
  self.fDelv1Icon:SetSize(15,15)
  self.fDelv2Icon:SetSize(15,15)
  self.fDelv3Icon:SetSize(15,15)
  self.cDelv1Icon:SetSize(15,15)
  self.cDelv2Icon:SetSize(15,15)
  self.cDelv3Icon:SetSize(15,15)
  
  -- Update DOF buff timers -- Tree
  treeTimer = treeTimer + 1
  minuteMod = math.fmod( treeTimer, 3600 )
  minutes   = ( minuteMod - math.fmod( minuteMod, 60   ) ) / 60
  hours     = ( treeTimer - math.fmod( treeTimer, 3600 ) ) / 3600
  
  if ( minutes < 10 ) then
    text = hours..":0"..minutes
  else
    text = hours..":"..minutes
  end
  
  if ( Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == Turbine.Gameplay.Alignment.MonsterPlayer ) then
    if ( ownTree ) then
      -- Enable creep side icon and text and set the text timer
      self.cDelv1Icon:SetVisible( true )
      self.cDelv1Time:SetVisible( true )
      self.cDelv1Time:SetText( text )
      
      -- Disable freep side icon and text
      self.fDelv1Icon:SetVisible( false )
      self.fDelv1Time:SetVisible( false )
    else
      -- Disable creep side icon and text
      self.cDelv1Icon:SetVisible( false )
      self.cDelv1Time:SetVisible( false )
      
      -- Enable freep side icon and text and set the text timer
      self.fDelv1Icon:SetVisible( true )
      self.fDelv1Time:SetVisible( true )
      self.fDelv1Time:SetText( text )      
    end
  else
    if ( ownTree ) then
      -- Enable freep side icon and text and set the text timer
      self.fDelv1Icon:SetVisible( true )
      self.fDelv1Time:SetVisible( true )
      self.fDelv1Time:SetText( text )      

      -- Disable creep side icon and text
      self.cDelv1Icon:SetVisible( false )
      self.cDelv1Time:SetVisible( false )
    else
      -- Disable freep side icon and text
      self.fDelv1Icon:SetVisible( false )
      self.fDelv1Time:SetVisible( false )
      
      -- Enable creep side icon and text and set the text timer
      self.cDelv1Icon:SetVisible( true )
      self.cDelv1Time:SetVisible( true )
      self.cDelv1Time:SetText( text )
    end
  end
  
  -- Update DOF buff timers -- Drake
  drakeTimer = drakeTimer + 1
  minuteMod  = math.fmod( drakeTimer, 3600 )
  minutes    = ( minuteMod  - math.fmod( minuteMod,  60   ) ) / 60
  hours      = ( drakeTimer - math.fmod( drakeTimer, 3600 ) ) / 3600
  
  if ( minutes < 10 ) then
    text = hours..":0"..minutes
  else
    text = hours..":"..minutes
  end
  
  if ( Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == Turbine.Gameplay.Alignment.MonsterPlayer ) then
    if ( ownDrake ) then
      -- Enable creep side icon and text and set the text timer
      self.cDelv3Icon:SetVisible( true )
      self.cDelv3Time:SetVisible( true )
      self.cDelv3Time:SetText( text )
      
      -- Disable freep side icon and text
      self.fDelv3Icon:SetVisible( false )
      self.fDelv3Time:SetVisible( false )
    else
      -- Disable creep side icon and text
      self.cDelv3Icon:SetVisible( false )
      self.cDelv3Time:SetVisible( false )
      
      -- Enable freep side icon and text and set the text timer
      self.fDelv3Icon:SetVisible( true )
      self.fDelv3Time:SetVisible( true )
      self.fDelv3Time:SetText( text )      
    end
  else
    if ( ownDrake ) then
      -- Enable freep side icon and text and set the text timer
      self.fDelv3Icon:SetVisible( true )
      self.fDelv3Time:SetVisible( true )
      self.fDelv3Time:SetText( text )      

      -- Disable creep side icon and text
      self.cDelv3Icon:SetVisible( false )
      self.cDelv3Time:SetVisible( false )
    else
      -- Disable freep side icon and text
      self.fDelv3Icon:SetVisible( false )
      self.fDelv3Time:SetVisible( false )
      
      -- Enable creep side icon and text and set the text timer
      self.cDelv3Icon:SetVisible( true )
      self.cDelv3Time:SetVisible( true )
      self.cDelv3Time:SetText( text )
    end
  end
	
  -- Update DOF buff timers -- Middle
  middleTimer = middleTimer + 1
  minuteMod   = math.fmod( middleTimer, 3600 )
  minutes     = ( minuteMod   - math.fmod( minuteMod,   60   ) ) / 60
  hours       = ( middleTimer - math.fmod( middleTimer, 3600 ) ) / 3600
  
  if ( minutes < 10 ) then
    text = hours..":0"..minutes
  else
    text = hours..":"..minutes
  end
  
  if ( Turbine.Gameplay.LocalPlayer.GetInstance():GetAlignment() == Turbine.Gameplay.Alignment.MonsterPlayer ) then
    if ( ownMiddle ) then
      -- Enable creep side icon and text and set the text timer
      self.cDelv2Icon:SetVisible( true )
      self.cDelv2Time:SetVisible( true )
      self.cDelv2Time:SetText( text )
      
      -- Disable freep side icon and text
      self.fDelv2Icon:SetVisible( false )
      self.fDelv2Time:SetVisible( false )
    else
      -- Disable creep side icon and text
      self.cDelv2Icon:SetVisible( false )
      self.cDelv2Time:SetVisible( false )
      
      -- Enable freep side icon and text and set the text timer
      self.fDelv2Icon:SetVisible( true )
      self.fDelv2Time:SetVisible( true )
      self.fDelv2Time:SetText( text )      
    end
  else
    if ( ownMiddle ) then
      -- Enable freep side icon and text and set the text timer
      self.fDelv2Icon:SetVisible( true )
      self.fDelv2Time:SetVisible( true )
      self.fDelv2Time:SetText( text )      

      -- Disable creep side icon and text
      self.cDelv2Icon:SetVisible( false )
      self.cDelv2Time:SetVisible( false )
    else
      -- Disable freep side icon and text
      self.fDelv2Icon:SetVisible( false )
      self.fDelv2Time:SetVisible( false )
      
      -- Enable creep side icon and text and set the text timer
      self.cDelv2Icon:SetVisible( true )
      self.cDelv2Time:SetVisible( true )
      self.cDelv2Time:SetText( text )
    end
  end

	for i=0, 14 do
		if (data.numbers.points_total >= Ranks[i] and data.numbers.points_total < Ranks[i+1]) then
			local rank_difference = Ranks[i+1] - Ranks[i]
			local points_since_rankup = data.numbers.points_total - Ranks[i]
			local percentage_done = points_since_rankup / rank_difference
			self.pic_rank:SetBackground(Rank_Icons[i])
			self.label_rank:SetText(L.Strings_Rank..i)
			self:UpdateProgressBar(percentage_done)
			return
		end
	end
	self.pic_rank:SetBackground(Rank_Icons[15])
	self.label_rank:SetText(L.Strings_Rank.."15")
	self:UpdateProgressBar(1) -- Rank 15
end

function OverviewWindow:SetTreeOwner(owner)
  ownTree = owner
end

function OverviewWindow:SetDrakeOwner(owner)
  ownDrake = owner
end

function OverviewWindow:SetMiddleOwner(owner)
  ownMiddle = owner
end

function OverviewWindow:IsTreeOwned()
  return ownTree
end

function OverviewWindow:IsDrakeOwned()
  return ownDrake
end

function OverviewWindow:IsMiddleOwned()
  return ownMiddle
end

function OverviewWindow:ResetTreeTimer()
  treeTimer = 0
end

function OverviewWindow:ResetDrakeTimer()
  drakeTimer = 0
end

function OverviewWindow:ResetMiddleTimer()
  middleTimer = 0
end

function OverviewWindow:UpdateProgressBar(percentage_done)
	self.percentage:SetText(math.floor(percentage_done*10000)/100 .. "%")
	local filled_pixel = math.floor(self.bar_length * percentage_done)	
	self.filled_bar:SetWidth(filled_pixel)
end

function OverviewWindow:UpdatePosition()
	local old_width = self:GetWidth()
	local new_width = math.floor(minimal_width + (Turbine.UI.Display.GetWidth() - minimal_width) * data.numbers.overview_width_ratio)
	if new_width / 2 ~= math.floor((new_width + 1) / 2) then new_width = new_width + 1 end -- true wenn new_width NICHT ohne rest durch 2 teilbar ist
	data.numbers.overview_x = data.numbers.overview_x - (new_width - old_width) / 2
	if data.numbers.overview_x < 0 then data.numbers.overview_x = 0 end
	if data.numbers.overview_x + new_width > Turbine.UI.Display.GetWidth() then data.numbers.overview_x = Turbine.UI.Display.GetWidth() - new_width end
	self:SetWidth(new_width)
	self:SetPosition(data.numbers.overview_x,data.numbers.overview_y)
	self:UpdateBarLength()
  self.panel:SetWidth(new_width)
  self.separator:SetWidth(new_width)
	self.commendations_panel:SetPosition(self:GetWidth()-54,18)
  self.points_panel:SetWidth(new_width)
  self.comms_panel:SetWidth(new_width)
  self.label_points:SetSize(new_width - 108,20) -- label direkt zwischen rank- und commendations-label
  self.label_day:SetSize(new_width/4,20)
  self.label_last_hour:SetSize(new_width/4,20)
	self.label_last_hour:SetPosition(new_width/4,0)
  self.label_10min:SetSize(new_width/4,20)
	self.label_10min:SetPosition(2 * new_width/4,0)
  self.label_last_fight:SetSize(new_width/4,20)
	self.label_last_fight:SetPosition(3 * new_width/4,0)
  self.label_day_comms:SetSize(new_width/4,20)
  self.label_last_hour_comms:SetSize(new_width/4,20)
  self.label_last_hour_comms:SetPosition(new_width/4,0)
  self.label_10min_comms:SetSize(new_width/4,20)
  self.label_10min_comms:SetPosition(2 * new_width/4,0)
  self.label_last_fight_comms:SetSize(new_width/4,20)
  self.label_last_fight_comms:SetPosition(3 * new_width/4,0)
	self.bonus_panel:SetPosition(new_width/2-self.bonus_panel:GetSize()/2,0)
	overview_settings_panel:SetPosition(self:GetLeft() + new_width - overview_settings_panel:GetWidth(), self:GetTop())
  -- Resize the DoF buffs
  self.fDelv1Icon:SetSize(15,15)
  self.fDelv2Icon:SetSize(15,15)
  self.fDelv3Icon:SetSize(15,15)
  self.cDelv1Icon:SetSize(15,15)
  self.cDelv2Icon:SetSize(15,15)
  self.cDelv3Icon:SetSize(15,15)
  self:Update()
end

function OverviewWindow:UpdateBarLength()
	self.bar_start = 50
	self.bar_end = self:GetWidth() - self.bar_start
	self.bar_length = self.bar_end - self.bar_start
	self.empty_bar:SetWidth(self.bar_length)
	self.middle:SetWidth(self.bar_length-6)
	self.right_end:SetPosition(self.bar_end-3,25)
	self.percentage:SetWidth(self:GetWidth())
end

function OverviewWindow:ToggleStatsVisibility()
	storage.stats_hidden = self.separator:IsVisible()
	self:SetStatsVisibility(not storage.stats_hidden)	
end
		
function OverviewWindow:SetStatsVisibility(flag)
	self.separator:SetVisible(flag)
	self.points_panel:SetVisible(flag)
end