SecondaryWindow = class(Turbine.UI.Window)

function SecondaryWindow:Constructor()

  local width = 140
  local height = 176

  Turbine.UI.Window.Constructor(self)
  
  self:SetSize(width,height)
  self:SetPosition(data.numbers.secondaryWin_x, data.numbers.secondaryWin_y)
	self:SetMouseVisible(false)
  self:SetOpacity(0.9)

  self.DragBar = DragBar(self, "PvMP+ HelperWindow")

  self.panel = Turbine.UI.Control()
  self.panel:SetParent(self)
  self.panel:SetSize(width, height-20)
  self.panel:SetTop(20)
  self.panel:SetBackColor(Turbine.UI.Color.Black)
	self.panel:SetMouseVisible(false)

  self.amount_label = Turbine.UI.Label()
  self.amount_label:SetParent(self.panel)
  self.amount_label:SetSize(55, 20)
  self.amount_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
  self.amount_label:SetPosition(5,5)
  self.amount_label:SetForeColor(default_font_color)
  self.amount_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
--  self.amount_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
  self.amount_label:SetText(L.Amount)
  self.amount_label:SetMouseVisible(false)

  self.amount_box = Turbine.UI.Lotro.TextBox()
  self.amount_box:SetParent(self.panel)
  self.amount_box:SetSize(25, 20)
  self.amount_box:SetPosition(self.amount_label:GetWidth() - 5,5)
--  self.amount_box:SetPosition(self.amount_label:GetWidth() + 5,5)
  self.amount_box:SetForeColor(default_font_color)
  self.amount_box:SetFont(Turbine.UI.Lotro.Font.TrajanPro14)
--  self.amount_box:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
  self.amount_box:SetMultiline(false)
  self.amount_box.oldText = ""
  self.amount_box.TextChanged = function()

    local input = string.gsub(self.amount_box:GetText(), "[ ,%.]", "")
    self.amount_box:SetText(tonumber(input))

    if tonumber(input) == nil then 
      if self.amount_box:GetText() == "" then
        self.amount_box.oldText = ""
        self:UpdateChatData()
      else
        self.amount_box:SetText(self.amount_box.oldText)
      end
    elseif tonumber(input) > 99 then
      self.amount_box:SetText(self.amount_box.oldText)
    else
      self.amount_box.oldText = tonumber(input)
      self:UpdateChatData()
    end
  end
  
  self.enemyLocContainer = Turbine.UI.Control()
	self.enemyLocContainer:SetParent(self.panel)
--	self.enemyLocContainer:SetSize(45,20)
	self.enemyLocContainer:SetSize(25,20)
	self.enemyLocContainer:SetPosition(self:GetWidth() - self.enemyLocContainer:GetWidth() - 5,5)

	self.enemyLocQS = Turbine.UI.Lotro.Quickslot()
	self.enemyLocQS:SetParent(self.enemyLocContainer)
	self.enemyLocQS:SetSize(self.enemyLocContainer:GetSize())
	self.enemyLocQS:SetUseOnRightClick(false)
  self.enemyLocQS:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, ''))
	self.enemyLocQS.MouseDown = function(sender,args)
    if args.Button == Turbine.UI.MouseButton.Right then
      self.contextMenu:ShowMenu()
    end
	end

  self.enemyLocOverlayBack=Turbine.UI.Control()
	self.enemyLocOverlayBack:SetParent(self.enemyLocContainer)
	self.enemyLocOverlayBack:SetSize(self.enemyLocContainer:GetSize())
  self.enemyLocOverlayBack:SetBackColor(default_font_color)
  self.enemyLocOverlayBack:SetMouseVisible(false)
  
	self.enemyLocOverlay=Turbine.UI.Label()
	self.enemyLocOverlay:SetParent(self.enemyLocContainer)
	self.enemyLocOverlay:SetSize(self.enemyLocContainer:GetWidth()-2, self.enemyLocContainer:GetHeight()-2)
  self.enemyLocOverlay:SetPosition(1,1)
  self.enemyLocOverlay:SetFont(Turbine.UI.Lotro.Font.Verdana10)
  self.enemyLocOverlay:SetBackColor(Turbine.UI.Color.Black)
	self.enemyLocOverlay:SetForeColor(default_font_color)
  self.enemyLocOverlay:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.enemyLocOverlay:SetText(L.Send)
  self.enemyLocOverlay:SetMouseVisible(false)

    self.enemyPosContainer = Turbine.UI.Control()
    self.enemyPosContainer:SetParent(self.panel)
  --	self.enemyPosContainer:SetSize(45,20)
    self.enemyPosContainer:SetSize(25,20)
    self.enemyPosContainer:SetPosition(self:GetWidth() - ( self.enemyPosContainer:GetWidth() * 2 ) - 10 ,5)

    self.enemyPosQS = Turbine.UI.Lotro.Quickslot()
    self.enemyPosQS:SetParent(self.enemyPosContainer)
    self.enemyPosQS:SetSize(self.enemyPosContainer:GetSize())
    self.enemyPosQS:SetUseOnRightClick(false)
    self.enemyPosQS:SetShortcut(Turbine.UI.Lotro.Shortcut(Turbine.UI.Lotro.ShortcutType.Alias, L.Loc))
    self.enemyPosQS.MouseDown = function(sender,args)
      if args.Button == Turbine.UI.MouseButton.Right then
        self.contextMenu:ShowMenu()
      end
    end

    self.enemyPosOverlayBack=Turbine.UI.Control()
    self.enemyPosOverlayBack:SetParent(self.enemyPosContainer)
    self.enemyPosOverlayBack:SetSize(self.enemyPosContainer:GetSize())
    self.enemyPosOverlayBack:SetBackColor(default_font_color)
    self.enemyPosOverlayBack:SetMouseVisible(false)
    
    self.enemyPosOverlay=Turbine.UI.Label()
    self.enemyPosOverlay:SetParent(self.enemyPosContainer)
    self.enemyPosOverlay:SetSize(self.enemyPosContainer:GetWidth()-2, self.enemyPosContainer:GetHeight()-2)
    self.enemyPosOverlay:SetPosition(1,1)
    self.enemyPosOverlay:SetFont(Turbine.UI.Lotro.Font.Verdana10)
    self.enemyPosOverlay:SetBackColor(Turbine.UI.Color.Black)
    self.enemyPosOverlay:SetForeColor(default_font_color)
    self.enemyPosOverlay:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.enemyPosOverlay:SetText("Pos")
    self.enemyPosOverlay:SetMouseVisible(false)
  
	self.contextMenu = Turbine.UI.ContextMenu()
	if data.numbers.selectedChannel2 == nil then
		data.numbers.selectedChannel2 = 5 -- 1 = say, 2 = fellow, 3 = raid, 4 = kin, 5 = OOC, 6 = uc1, 7 = uc2, 8 = uc3, 9 = uc4
	end
  
  for i = 2, #L.ChatChannels - 4 do
    self:AddChatChannel(L.ChatChannels[i][2])
  end

  self.recent_kills_panel = Turbine.UI.Control()
	self.recent_kills_panel:SetParent(self.panel)
	self.recent_kills_panel:SetSize(self.panel:GetWidth() - 10, 97)
  self.recent_kills_panel:SetBackColor(default_font_color)
  self.recent_kills_panel:SetMouseVisible(false)
  self.recent_kills_panel:SetPosition(5,32)

  self.recent_kills_label = Turbine.UI.Label()
  self.recent_kills_label:SetParent(self.recent_kills_panel)
  self.recent_kills_label:SetSize(self.recent_kills_panel:GetWidth() - 2, 20)
  self.recent_kills_label:SetPosition(1,1)
  self.recent_kills_label:SetBackColor(Turbine.UI.Color.Black)
  self.recent_kills_label:SetForeColor(default_font_color)
  self.recent_kills_label:SetFont(Turbine.UI.Lotro.Font.TrajanPro15)
  self.recent_kills_label:SetFontStyle(Turbine.UI.FontStyle.Outline)
  self.recent_kills_label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  self.recent_kills_label:SetText(L.RecentKills)
  self.recent_kills_label:SetMouseVisible(false)

  self.recent_kills = Turbine.UI.ListBox()
  self.recent_kills:SetParent(self.recent_kills_panel)
  self.recent_kills:SetSize(self.recent_kills_panel:GetWidth()-2, self.recent_kills_panel:GetHeight()-22)
  self.recent_kills:SetPosition(1,21)
  self.recent_kills:SetBackColor(Turbine.UI.Color(48/255,48/255,48/255))
  self.recent_kills.maxEntries = 5
  self.recent_kills:SetMouseVisible(false)
  self:InitRecentKillsList()
  
  self.showhide = Turbine.UI.Lotro.Button()
  self.showhide:SetParent(self.panel)
  self.showhide:SetWidth(width - 10)
  self.showhide:SetPosition(5, 132)
  self.showhide:SetText(L.ShowMap)
  self.showhide.Click = function()
    mapWindow:SetVisible(not mapWindow:IsVisible())
    if mapWindow:IsVisible() then
      self.showhide:SetText(L.HideMap)
    else
      self.showhide:SetText(L.ShowMap)
    end
  end

  self.VisibleChanged = function(sender)
    if not sender:IsVisible() then
      mapWindow:SetVisible(false)
      self.showhide:SetText(L.ShowMap)
    end
  end
  
  self.PositionChanged = function()
		data.numbers.secondaryWin_x = self:GetLeft()
		data.numbers.secondaryWin_y = self:GetTop()
  end

  self:ShowRecentKills(not storage.show_recent_kills_disabled)
  self:UpdateChatData()
end

function SecondaryWindow:InitRecentKillsList()

  for i = 1, 5 do
  listItem = self:GetRecentKillsListItem(storage.last5kills[tostring(i)])
    self.recent_kills:InsertItem(1, listItem)
  end
end

function SecondaryWindow:NewRecentKill(name)

  for i = 1, 4 do
    storage.last5kills[tostring(i)] = storage.last5kills[tostring(i + 1)]
  end
  storage.last5kills["5"] = name

  if self.recent_kills:GetItemCount() == self.recent_kills.maxEntries then
    self.recent_kills:RemoveItemAt(self.recent_kills:GetItemCount())
  end

  listItem = self:GetRecentKillsListItem(name)
  self.recent_kills:InsertItem(1, listItem)
end

function SecondaryWindow:GetRecentKillsListItem(name)

  local item = Turbine.UI.Label()
  item:SetFont(Turbine.UI.Lotro.Font.Verdana14)
  item:SetSize(self.recent_kills:GetWidth(), self.recent_kills:GetHeight()/self.recent_kills.maxEntries)
  item:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
  item:SetMouseVisible(false)
  item:SetText(name)

  return item
end

function SecondaryWindow:UpdateChatData()

  local amount = self.amount_box:GetText()
  local nospace = (amount == "")
  local sc = self.enemyLocQS:GetShortcut()
  sc:SetData(
    "/"..L.ChatChannels[data.numbers.selectedChannel2][1].." <rgb="..posChatColor..">"..amount..(nospace and "" or " ")..
    (amount == "1" and L.FreepCreep or L.FreepsCreeps).." @ "..L.Loc2.."</rgb>"
  )

  self.enemyLocQS:SetShortcut(sc)
  self.enemyLocQS:SetAllowDrop(false)
end

function SecondaryWindow:DisplayChatData(west, south, heading)

  local amount         = self.amount_box:GetText()
  local nospace        = (amount == "")
  local sc             = self.enemyLocQS:GetShortcut()
  
  local bestIndex      = 0
  local distance       = 0.0
  local angleToPoint   = 0.0
  local bestDistance   = 10000.0
  local bestDistanceM  = 0.0
  local directionIndex = 0
  local degreesToM     = 0.005 -- Game degrees to meters conversion factor
  local stringdata     = ""
  local sidestring     = ""
  local delving        = ""

  local Map_POIs = {
    [1]  = { ["w"] =  17.25095, ["s"] = 16.37975, ["radius"] = 70  }, -- TA
    [2]  = { ["w"] =  15.60865, ["s"] = 11.63915, ["radius"] = 75  }, -- Isendeep Mine
    [3]  = { ["w"] =  14.42685, ["s"] = 17.50920, ["radius"] = 60  }, -- TR
    [4]  = { ["w"] =  20.00475, ["s"] = 15.31895, ["radius"] = 60  }, -- Lugz
    [5]  = { ["w"] =  17.34680, ["s"] = 19.26070, ["radius"] = 60  }, -- LC
    [6]  = { ["w"] =  19.28350, ["s"] = 19.86165, ["radius"] = 25  }, -- HOP
    [7]  = { ["w"] =  14.58685, ["s"] = 13.43640, ["radius"] = 25  }, -- AEOP
    [8]  = { ["w"] =  20.08330, ["s"] = 18.41825, ["radius"] = 25  }, -- ROP
    [9]  = { ["w"] =  16.15525, ["s"] = 14.51480, ["radius"] = 25  }, -- IOP
    [10] = { ["w"] =  20.67795, ["s"] = 13.05815, ["radius"] = 75  }, -- Grams
    [11] = { ["w"] =  13.78070, ["s"] = 20.36850, ["radius"] = 75  }, -- GV
    [12] = { ["w"] =  19.78805, ["s"] = 16.98545, ["radius"] = 30  }, -- Elf Camp
    [13] = { ["w"] =  15.26160, ["s"] = 15.85570, ["radius"] = 35  }, -- Orc Camp
    [14] = { ["w"] =  17.87980, ["s"] = 13.09010, ["radius"] = 80  }, -- Grothum
    [15] = { ["w"] =  22.35495, ["s"] = 17.00280, ["radius"] = 100 }, -- DG
    [16] = { ["w"] =  12.07185, ["s"] = 15.99960, ["radius"] = 75  }, -- Ost
    [17] = { ["w"] =  20.01595, ["s"] = 19.84560, ["radius"] = 100 }, -- HH
    [18] = { ["w"] = -52.14305, ["s"] = 65.74370, ["radius"] = 50  }, -- Delving AEOP
    [19] = { ["w"] = -53.34585, ["s"] = 65.84415, ["radius"] = 40  }, -- Delving Drake
    [20] = { ["w"] = -53.98960, ["s"] = 66.37240, ["radius"] = 50  }, -- Delving IOP
    [21] = { ["w"] = -54.35900, ["s"] = 66.74245, ["radius"] = 50  }, -- Delving Ost
    [22] = { ["w"] = -54.00110, ["s"] = 66.88535, ["radius"] = 50  }, -- Delving OC
    [23] = { ["w"] = -54.42450, ["s"] = 67.54170, ["radius"] = 50  }, -- Delving HOP
    [24] = { ["w"] = -53.17050, ["s"] = 67.40525, ["radius"] = 40  }, -- Delving Tree
    [25] = { ["w"] = -52.52000, ["s"] = 66.85785, ["radius"] = 50  }, -- Delving ROP
    [26] = { ["w"] = -52.18750, ["s"] = 66.55385, ["radius"] = 50  }, -- Delving DG
    [27] = { ["w"] = -52.54710, ["s"] = 66.40360, ["radius"] = 50  }, -- Delving EC
    [28] = { ["w"] = -53.33655, ["s"] = 66.67595, ["radius"] = 50  }  -- Delving Middle
  }

  -- Search for the closest map point
  for index,map in pairs(Map_POIs) do
  
    distance = math.sqrt( ( ( west - map.w ) * ( west - map.w ) ) + ( ( south - map.s ) * ( south - map.s ) ) )
    
    if ( distance < bestDistance ) then
      bestDistance = distance
      bestIndex    = index
    end
    
  end

  --alertWindow:NewAlert("west "..west.."   south "..south, Turbine.UI.Color.Lime, 3) 
  
  -- Compute the distance in meters
  bestDistanceM = math.floor( ( bestDistance / degreesToM ) + 0.5 )
  
  -- Compute the angle to the closest map point
  angleToPoint = math.deg( math.atan2( Map_POIs[bestIndex].w - west, Map_POIs[bestIndex].s - south ) )
  
  if ( angleToPoint < 0.0 ) then
    angleToPoint = angleToPoint + 360.0
  end
  
  -- Figure out the directional letter (letters in globals)
  if ( angleToPoint >= 337.5 or angleToPoint <= 22.5 ) then -- North
    directionIndex = 1
  elseif ( angleToPoint >= 67.5 and angleToPoint <= 112.5 ) then -- East
    directionIndex = 3
  elseif ( angleToPoint >= 157.5 and angleToPoint <= 202.5 ) then -- South
    directionIndex = 5
  elseif ( angleToPoint >= 247.5 and angleToPoint <= 292.5 ) then -- West
    directionIndex = 7
  elseif ( angleToPoint >= 22.5 and angleToPoint <= 67.5 ) then -- North East
    directionIndex = 2
  elseif ( angleToPoint >= 112.5 and angleToPoint <= 157.5 ) then -- South East
    directionIndex = 4
  elseif ( angleToPoint >= 202.5 and angleToPoint <= 247.5 ) then -- South West
    directionIndex = 6
  elseif ( angleToPoint >= 272.5 and angleToPoint <= 337.5 ) then -- North West
    directionIndex = 8
  end
  
  -- Build the precursor string
  if ( amount == "" ) then
    sidestring = L.FreepsCreeps
  elseif ( amount == "1" ) then
    sidestring = "1 "..L.FreepCreep
  else
    sidestring = amount.." "..L.FreepsCreeps
  end
  
  -- Build the delving string if applicable
  if ( west < 0.0 ) then
    delving = " in Delving "
  end
  
  -- Build the string to display based on how close we are.  Inside radius is one message, outside radius is another
  if ( bestDistanceM <= Map_POIs[ bestIndex ].radius ) then
    -- 8 Freeps @ AEOP   -OR-
    -- 8 Freeps in Delving @ AEOP
    stringdata = "/"..L.ChatChannels[ data.numbers.selectedChannel2 ][ 1 ].." <rgb="..posChatColor..">"..sidestring..delving.." @ "..map_positions[ bestIndex ]
  else
    -- 8 Freeps 25m NW AEOP   -OR-
    -- 8 Freeps in Delving 25m NW AEOP
    stringdata = "/"..L.ChatChannels[ data.numbers.selectedChannel2 ][ 1 ].." <rgb="..posChatColor..">"..sidestring..delving.." "..bestDistanceM.."m "..directions[ directionIndex ].." "..map_positions[ bestIndex ]
  end

  --alertWindow:NewAlert( stringdata, Turbine.UI.Color ( .95,.67,.04 ), 5 )    
  
  -- Set the string data
  sc:SetData ( stringdata )
  self.enemyLocQS:SetShortcut ( sc )
--  self.enemyLocQS:SetAllowDrop(false)

end

function SecondaryWindow:ShowRecentKills(show)

  if show then
    self:SetHeight(176)
    self.panel:SetHeight(156)
    self.recent_kills_panel:SetVisible(true)
    self.showhide:SetTop(132)
  else
    self:SetHeight(176-self.recent_kills_panel:GetHeight() - 5)
    self.panel:SetHeight(156-self.recent_kills_panel:GetHeight() - 5)
    self.recent_kills_panel:SetVisible(false)
    self.showhide:SetTop(132-self.recent_kills_panel:GetHeight() - 5)
  end
end

function SecondaryWindow:AddChatChannel(channelname, isUserChannel)

  local index = self.contextMenu:GetItems():GetCount() + 1

  if isUserChannel then
    for i = 1, 4 do
      if usedUserChannels[i] == nil then
        index = 4 + i
        break
      end
    end
  end

  local menuItem = Turbine.UI.MenuItem(channelname, true, data.numbers.selectedChannel2 == index + 1)
  menuItem.Click = function(sender)
    for j = 1, self.contextMenu:GetItems():GetCount() do self.contextMenu:GetItems():Get(j):SetChecked(false) end
    sender:SetChecked(true)
    data.numbers.selectedChannel2 = index + 1
    self:UpdateChatData()
  end
  self.contextMenu:GetItems():Insert(index, menuItem)
end

function SecondaryWindow:RemoveChatChannel(channelname)

  local contextMenuItemList = self.contextMenu:GetItems()
  for j = 1, contextMenuItemList:GetCount() do
    if string.lower(contextMenuItemList:Get(j):GetText()) == string.lower(channelname)then
      for i = 1, 4 do
        if usedUserChannels[i] == string.lower(channelname) then
          usedUserChannels[i] = nil
          break
        end
      end
      contextMenuItemList:RemoveAt(j)
      return
    end
  end
end